#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/file.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "config.h"
#include "struct.h"
#include "proto.h"
#include "thread.h"
#include "portaloo.h"
#include "cgi.h"

extern int thread_size;
extern struct thread_tree *articles;

void add_comment_request(int replyto, char *fol)
{
	if(!(self.flags[0]&FLAGS0_NAME_SET))
	{
		get_an_account("Only registered users may post. If you wish to post please apply for an account.\n");
		exit(0);
	}
	print_header("Portaloo - Add Comment");

	if (replyto<0 || replyto>=thread_size)
	{
		printf("You cant reply to a message that doesnt exist<br>\n");
		print_footer();
		exit(0);
	}
		
	printf("Reply to comment %d in folder %s\n", replyto, fol);

	article_full(articles[replyto].article, 0, 0, 0);

	printf("<TD></TR><TR><TD bgcolor=\"#000000\">\n");
	printf("<b><font face=helvetica color=white size=+1>Compose new comment...</font></b></TD></TR>\n");
	printf("<TR><TD>\n");
	printf("<form action=%s method=get>\n", CGIPATH);
	printf("<input type=hidden name=action value=add>\n");
	printf("<input type=hidden name=fol value=%s>\n", fol);
	printf("<input type=hidden name=replyto value=%d>\n", replyto);
	printf("<input type=hidden name=clock value=%d>\n", 
		self.count[POST_COUNT]);

	printf("<table border=0 bgcolor=#eeeebb cellspacing=0>\n");

	printf("<tr><td align=left>From:</td><td><b>%s</b></td>",
		self.uname);
	printf("<tr><td align=left>Subject:</td>");
	printf("<td><input type=text name=subject size=%d maxsize=%d value=\"%s\"></td></tr>\n", SUBJECTSIZE, SUBJECTSIZE , articles[replyto].article.subject);

	printf("<tr><td colspan=2>");
	printf("<textarea name=text rows=10 cols=60>");
	printf("</textarea></td></tr>\n");

	printf("<tr><td colspan=2>\n");
	printf("<table border=0>\n");
	printf("<tr>\n");
	printf("<td><input type=radio name=icon value=0> %s None</td>\n", small_icon(0));
	printf("<td><input type=radio name=icon value=1> %s Agree</td>\n", small_icon(1));
	printf("<td><input type=radio name=icon value=2> %s Disagree</td>\n", small_icon(2));
	printf("<td><input type=radio name=icon value=3> %s News</td>\n", small_icon(3));
	printf("</tr><tr>\n");
	printf("<td><input type=radio name=icon value=4> %s Idea</td>\n", small_icon(4));
	printf("<td><input type=radio name=icon value=5> %s Question</td>\n", small_icon(5));
	printf("<td><input type=radio name=icon value=6> %s Smile</td>\n", small_icon(6));
	printf("<td><input type=radio name=icon value=7> %s Answer</td>\n", small_icon(7));
	printf("</tr></table>\n");
	printf("</td></tr>\n");

	printf("<tr><td colspan=2 align=center>");
	printf("<input type=submit name=submit value=\"Submit Comment\">");
	printf("</td></tr>\n");
	
	printf("</table>\n");
	printf("</form>\n");

	printf("</td></tr></table>\n"); /* close the article table */
	print_footer();
	exit(0);
}

void add_comment(char *fol)
{
	struct Header new, old;
	int fi, ft;
	char *c;
	int i;
	char path[512];
	char *xp;


	if(!(self.flags[0]&FLAGS0_NAME_SET))
	{
		get_an_account("Only registered users may post. If you wish to post please apply for an account.\n");
		exit(0);
	}
	new.date=time(0);
	if ((c=cgi_find("replyto"))==NULL)
		new.replyto=0;
	else
		new.replyto=atoi(c);

	strcpy(new.from, self.uname);
	new.from[NAMESIZE]=0;
	
	if ((c=cgi_find("subject"))==NULL)
		strcpy(new.subject, "No Subject");
	else
		html_strncpy(new.subject, c, SUBJECTSIZE);
	new.subject[SUBJECTSIZE]=0;

	if ((c=cgi_find("icon"))==NULL)
		new.icon=0;
	else
		new.icon=atoi(c);

	if ((c=cgi_find("text"))==NULL)
		c="No Text";

	xp=html_filter(c);
	new.size=strlen(xp);

	snprintf(path, 512, "%s/%s.i", HOMEPATH, fol);
	if ((fi=open(path, O_RDWR))<0)
		html_error("argh");
	flock(fi, LOCK_EX);
	lseek(fi, -1 * sizeof(old), SEEK_END);
	read(fi, &old, sizeof(old));
	new.Ref=old.Ref+1;

	snprintf(path, 512, "%s/%s.t", HOMEPATH, fol);
	if ((ft=open(path, O_WRONLY))<0)
		html_error("arghh");
	i=lseek(ft, 0, SEEK_END);
	new.datafield=i;
	write(fi, &new, sizeof(new));
	write(ft, xp, new.size);
	close(ft);
	flock(fi, LOCK_UN);
	close(fi);
}

char *small_icon(int n)
{
	static char res[256];
	switch (n) {
		case 1: snprintf(res, 256, "<img src=%s/small/th_up.gif alt=\"\" align=top>", IMAGEDIR); break;
		case 2: snprintf(res, 256, "<img src=%s/small/disagree.gif alt=\"\" align=top>", IMAGEDIR); break;
		case 3: snprintf(res, 256, "<img src=%s/small/news.gif alt=\"\" align=top>", IMAGEDIR); break;
		case 4: snprintf(res, 256, "<img src=%s/small/idea.gif alt=\"\" align=top>", IMAGEDIR); break;
		case 5: snprintf(res, 256, "<img src=%s/small/question.gif alt=\"\" align=top>", IMAGEDIR); break;
		case 6: snprintf(res, 256, "<img src=%s/small/smile.gif alt=\"\" align=top>", IMAGEDIR); break;
		case 7: snprintf(res, 256, "<img src=%s/small/answer.gif alt=\"\" align=top>", IMAGEDIR); break;
	
		default: strcat(res,"");
	}
	return(res);
}
