#include <stdio.h>
#include <string.h>
#include <gdbm.h>
#include <readline/readline.h>

#include "config.h"
#include "struct.h"

int main(int argc, char **argv)
{
	char *c;
	GDBM_FILE db;
	datum key, data;
	char path[512];

	/* record text strings, including the terminator */
	if ((c=readline("Username:"))==NULL) exit(0);
	key.dptr=strdup(c);
	key.dsize=strlen(c)+1;

	if ((c=readline("Password:"))==NULL) exit(0);
	data.dptr=strdup(c);
	data.dsize=strlen(c)+1;

	snprintf(path, 512, "%s/user.db", HOMEPATH);
	if ((db=gdbm_open(path, 1024, GDBM_WRCREAT, 0600, NULL))==NULL)
	{
		printf("Opening: %s\n", gdbm_strerror(gdbm_errno));
		exit(0);
	}

	if (gdbm_store(db, key, data, GDBM_REPLACE) !=0)
		printf("Store: %s\n", gdbm_strerror(gdbm_errno));
	gdbm_close(db);
}
